#!/bin/sh
LD_PRELOAD=
echo "Netexec PRO 2.0 bu VINRARUS 2018"
DVA="$2"
if [ "$DVA" = "-s" ]
then
    showNotify()
    {
    echo "$@"
    }
fi

NASTROYKA=`cat /ezxlocal/download/appwrite/setup/netexec.cfg`
export LD_LIBRARY_PATH="${0%/*}:$LD_LIBRARY_PATH"
SPRAVKA="Netexec PRO 2.0

Netexec PRO - client for connection with GPRS, WiFi, USB.
bu VINRARUS 2018

Usage: \`cat /ezxlocal/download/netexec\` [option 1] [-s]

Options number 1:
-help  -  this info
start  -  start netexec only
START -   start netexec from write pid in log
stop    - stop netexec if not active pid in log
STOP  -   stop netexec force and clear log

Options number 2:
-s   -    quiet start, not dialogs

Code closing (\$?)
0 - OK
1 - ERROR
2 - OK for this pid

goodbye fun egg =)
"

if [ -f "/etc/resolv.conf" ]
then
    if [ "`cat /etc/resolv.conf`" != "nameserver 8.8.8.8" ]
    then
        if ! echo "nameserver 8.8.8.8" > /etc/resolv.conf
        then
            echo "nameserver 8.8.8.8" > /ezxlocal/resolv.conf
            mount -o bind /ezxlocal/resolv.conf /etc/resolv.conf
        fi
    fi
else
showNotify "Netexec PRO" "Критическая ошыбка!
Отсутствует /etc/resolv.conf" 1 3
fi
#
PIPI(){
if [ -z "$PROFILS" ]
then
    PROFILS=`${0%/*}/netexec4sh | sed -e '15,88!d' -e 's/^[0-9]*\. //'`
#    PROFILS=`${0%/*}/netexec4sh | sed -e '15,88!d' -e 's/^[0-9]*\. //' | sed ':a;N;$!ba;s/ /_/g;s/\n/ /g'`
    if [ -z "$PROFILS" ]
    then
        showNotify "Netexec PRO" "Ошыбка загрузки профилей!" 2 3
        PROFILS="WiFi
USB"
#        exit 1
    fi
PROFILS="$PROFILS
USB"
fi
}
LISTIK(){
PIPI
STROKA=`echo "$PROFILS" | sed -e 's/ //g' -e ':a;N;$!ba;s/ /_/g;s/\n/ /g'`
if [ -z "$STROKA" ]
then
    showNotify "Netexec PRO" "Ошыбка обработки списка профилей!" 1 3
fi
if [ -n "$NASTROYKA" ]
then
    STROYKA="Профиль по умолчанию:
$NASTROYKA"
else
    STROYKA=
fi
showRadio "Netexec PRO" "$STROYKA" $STROKA
VIBOR=$?
if  [ "$VIBOR" = "0" ]
then
    exit 1
fi
VOT=`echo "$PROFILS" | sed "${VIBOR}!d"`
}
STOP(){
killall Netexec.daemon
killall netexec4sh
killall Netexec.zInterval
route delete default
if grep WIFI /tmp/netexec.log
then
    rm -f /tmp/netexec.log
    killall wlanapp_somnus
else
    rm -f /tmp/netexec.log
fi
}
DEMON(){
if pidof Netexec.daemon
then
    killall Netexec.daemon
    killall netexec4sh
    killall Netexec.zInterval
fi
${0%/*}/Netexec.daemon "$1" &
}
CHECK(){
for POP in `cat /tmp/netexec.log`
do
    echo "check PID $POP..."
    Z=
    if [ -f "/proc/$POP/status" ]
    then
        read X Y Z O < /proc/$POP/stat
        if [ "$Z" = "Z" ]
        then
            echo "$POP is zombi, remove him."
            sed -i "/^$POP$/d" /tmp/netexec.log
        else
            echo "$POP is running!"
            return 2
        fi
    elif [ "$POP" = "WIFI" ]
    then
        echo "hello WiFi"
    else
        echo "$POP is missing, remove him."
        sed -i "/^$POP$/d" /tmp/netexec.log
    fi
done
}
CLEAR(){
shift
while [ -n "$*" ]
do
    sed -i "/^$1$/d" /tmp/netexec.log
    shift
done
}
ADD(){
if [ -z "$1" ]
then
    return
elif [ -f "/proc/$1/status" ]
then
    if grep "^$1$" /tmp/netexec.log
    then
        echo "PID $1 is added before"
    else
        echo "add PID $1"
        echo "$1" >> /tmp/netexec.log
    fi
else
    echo "PID $1 is not real"
fi
shift
}
ZAPUSK(){
if busybox ping -c 1 google.com
then
    echo "Conect is OK!!!!"
    PING=0
    return $PING
#else
#    PIPI
fi
if [ -z "$NASTROYKA" ]
then
#    showNotify "Netexec PRO" "Не настроен профиль!" 2 2
    LISTIK
#    echo "$VOT" > /ezxlocal/download/appwrite/setup/netexec.cfg
####NASTROYKA=AUTO:GPRS_profile####
elif [ "${NASTROYKA%%:*}" = "AUTO" ]
then
    if pidof wlanapp_somnus
    then
        if [ -f "/ezxlocal/download/appwrite/NetProfile/${NASTROYKA#*:}" ]
        then
            VVOT="${NASTROYKA#*:}"
            VVVOT="zona52"
        fi
        NASTROYKA="WiFi"
    elif [ "${NASTROYKA#*:}" = "$NASTROYKA" ]
    then
        NASTROYKA=
    else
        NASTROYKA="${NASTROYKA#*:}"
    fi
    ZAPUSK
    return
elif [ "WiFi" = "$NASTROYKA" ]
then
    VOT="WiFi"
elif [ "USB" = "$NASTROYKA" ]
then
    VOT="USB"
elif [ -f "/ezxlocal/download/appwrite/NetProfile/$NASTROYKA" ]
then
    VOT="$NASTROYKA"
else
    showNotify "Netexec PRO" "Не существует профиль!" 2 2
    LISTIK
#    echo "$VOT" > /ezxlocal/download/appwrite/setup/netexec.cfg
fi
if [ "$VOT" = "WiFi" -o "$VOT" = "WIFI"  ]
then
    if pidof wpa_supplicant && grep sd8xxx /proc/modules
    then
        echo "Conect Wi-Fi is ok"
    else
        if grep sd8xxx /proc/modules
        then
            SEMAX=15
        else
            SEMAX=25
        fi
        echo "Conecting to Wi-Fi..."
        /usr/SYSqtapp/wlan/wlanapp -quickconnect &
        echo WIFI >> /tmp/netexec.log
        SE=0
        while pidof wlanapp
        do
            sleep 1
            if pidof wpa_supplicant
            then
                echo "ok"
                killall wlanapp
                break
            elif [ "$SE" = "$SEMAX" ]
            then
                echo "fail, time out"
                killall wlanapp
                break
            fi
            let SE++
        done
    fi
    sleep 1
    GATEWAY=`sed -e '/GATEWAY=/!d' -e 's/GATEWAY=//g' /ezxlocal/dhcpc/dhcpcd-eth0.info`
    if [ -n "$GATEWAY" ]
    then
        route add default gw "$GATEWAY"
    fi
########################################################
    
    if busybox ping -c 1 google.com
    then
        VVOT=
        VVVOT=
    else
        sleep 1
        GATEWAY=`sed -e '/GATEWAY=/!d' -e 's/GATEWAY=//g' /ezxlocal/dhcpc/dhcpcd-eth0.info`
        if [ -n "$GATEWAY" ]
        then
            route add default gw "$GATEWAY"
        fi
        if busybox ping -c 1 google.com
        then
            VVOT=
            VVVOT=
        fi
    fi
    if [ -n "$VVVOT" ]
    then
        VVVOT=
        ZAPUSK
        return

    elif [ -n "$VVOT" ]
    then
        NASTROYKA="$VVOT"
        ZAPUSK
        return
    else    
        DEMON "WiFi"
    fi
elif [ "$VOT" = "USB"  ]
then
    echo "Conected to USB..."
    ifconfig usbl0 192.168.16.2 broadcast 192.168.16.7 netmask 255.255.255.248
    route add default gw 192.168.16.1
else
    echo "Conected to GPRS..."
    if [ "$DVA" != "-s" ]
    then
        (if showQ "Netexec PRO" "Подключение к GPRS через $VOT..." 0
        then
            STOP
        fi) &
        showQ=1
    fi
    DEMON "$VOT"
fi
if busybox ping -c 1 google.com
then
    PING=0
else
    for N in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35
    do
        if ! pidof Netexec.daemon
        then
            PING=1
            break
        elif busybox ping -c 1 google.com
        then
            echo OK
            PING=0
            break
        fi
        sleep 1
        PING=1
    done
fi
if [ "$PING" != 0 ]
then
    PING=1
    showNotify "Netexec PRO" "Ошыбка подключения!" 2 2 &
    STOP
else
    showNotify "Netexec PRO" "К WEB подключен." 0 1 &
fi
if [ "$showQ" = 1 ]
then
    killall showQ
fi
return $PING
}
POSTROYKA(){
    showRadio "Netexec PRO" "Использовать как стандартный профиль:" "всегда спрашывать" "токо Wi-Fi" "AUTO Wi-Fi>>профиль" "AUTO Wi-Fi>>вопрос" "профиль"
    case $? in
    0)
        exit
    ;;
    1)
        rm -f /ezxlocal/download/appwrite/setup/netexec.cfg
    ;;
    2)
        echo "WiFi" > /ezxlocal/download/appwrite/setup/netexec.cfg
    ;;
    3)
        LISTIK
        echo "AUTO:$VOT" > /ezxlocal/download/appwrite/setup/netexec.cfg
    ;;
    4)
        echo "AUTO" > /ezxlocal/download/appwrite/setup/netexec.cfg
    ;;
    5)
        LISTIK
        echo "$VOT" > /ezxlocal/download/appwrite/setup/netexec.cfg
    ;;
    esac

}
PUPSIK(){
if [ "$0" != "`cat /ezxlocal/download/netexec`" ]
then
    echo "$0" > /ezxlocal/download/netexec
    showNotify "Netexec PRO" "Исправление ссылки..." 1 2 &
fi
if [ -z "$NASTROYKA" ]
then
    NASTOYKA="?"
else
    NASTOYKA="$NASTROYKA"
fi
if busybox ping -c 1 google.com
then
    showRadio "Netexec PRO" "Online for PID: `sed 's/WIFI//' /tmp/netexec.log | sed -n 'H;${g;s/\n/ /g;p}'`" "Отключить от WEB" "Сменить профиль" "*$NASTOYKA" "I N F O"
    case $? in
    0)
        exit
    ;;
    1)
        STOP
        rm -f /tmp/netexec.log
        showNotify "Netexec PRO" "Выключен" 0 1
    ;;
    2)
        LISTIK
        STOP
        ZAPUSK
    ;;
    3)
        POSTROYKA
    ;;
    4)
        showQ "Netexec PRO" "`$0 -help`" 2
    ;;
    esac
else
    showRadio "Netexec PRO" "OFFline" "Подключить в WEB" "С другим профилем" "*$NASTOYKA" "I N F O"
    case $? in
    0)
        exit
    ;;
    1)
        VOT="$NASTROYKA" 
        ZAPUSK
        echo 1 >> /tmp/netexec.log
    ;;
    2)
        LISTIK
        ZAPUSK
        echo 1 >> /tmp/netexec.log
    ;;
    3)
        POSTROYKA
    ;;
    4)
        showQ "Netexec PRO" "`$0 -help`" 2
    ;;
    esac
fi
}
case "$1" in
-help|-HELP|-h|--h|--help)
    echo "$SPRAVKA"
    exit
;;
start)
    if ZAPUSK
    then
        ADD "$@"
    fi
    exit $PING
;;
START)
    if ZAPUSK
    then
        ADD "$PPID" "$@"
    fi
    exit $PING
;;
stop)
    CLEAR "$@" "$PPID"
    if CHECK
    then
        STOP
        if busybox ping -c 1 google.com
        then
            showNotify "Netexec PRO" "Не выключается" 2 2 &
            exit 1
        else
            showNotify "Netexec PRO" "Выключен" 0 1 &
            exit 0
        fi
    else
        exit 2
    fi
;;
STOP)
    STOP
    if busybox ping -c 1 google.com
    then
        showNotify "Netexec PRO" "Не выключается" 2 2 &
        exit 1
    else
        showNotify "Netexec PRO" "Выключен" 0 1 &
        exit 0
    fi
;;
RESTART)
    exit $?
;;
*)
    echo menus
    PUPSIK
;;
esac
